import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.applet.*;
import Client;

class Tris extends Applet implements ActionListener, Runnable, WindowListener {
	
	int white,black;
	String MyName;
	ObjectInputStream in;										// Stream di input
	ObjectOutputStream out,end;									// Stream di output
	boolean first,call;													// Indica se sono il primo a partire
	Frame f;																// Il frame nel quale  contenuta l'applet Tris
	Button[] buttArray = new Button[9];				// I nove bottoni della griglia
	boolean[] enabled = new boolean[9];				// Array che indica i bottoni non ancora premuti
	Client app;
	String player;
	List resultArea;
	
	void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh, int wx, int wy) {
		gbc.gridx = gx;
		gbc.gridy = gy;
		gbc.gridwidth = gw;
		gbc.gridheight = gh;
		gbc.weightx = wx;
		gbc.weighty = wy;
 	}
	
	Tris (ObjectInputStream i, ObjectOutputStream o,ObjectOutputStream e,String nome, boolean primo,boolean c,String white, String black, Client client, String opponent) {
		super();													// Chiamo il costruttore della superclasse Applet
		setName("Tris");									// Inizializzo le variabili istanza
		player=opponent;
		in=i;				
		out=o;
		end=e;//adibito alla comunicazione di stop partita
		call=c;				
		MyName=nome;									
		first=primo;
		this.white= Integer.valueOf(white).intValue();
		this.black= Integer.valueOf(black).intValue();
		app=client;
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();	
		setLayout(gridbag);
		setBackground(Color.lightGray);
		// Area risultati partite
		buildConstraints(constraints, 3, 0, 1, 3, 0, 0);
		constraints.fill = GridBagConstraints.BOTH;
		resultArea = new List();
		gridbag.setConstraints(resultArea, constraints);
		add(resultArea);
		// Save Button
		buildConstraints(constraints, 4, 0, 1, 1, 25, 0);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Button saveButton =new Button("Save");
		SaveListener saveThis=new SaveListener(this);
		gridbag.setConstraints(saveButton, constraints);
		add(saveButton);
		saveButton.addActionListener(saveThis);
		// Exit Button
		buildConstraints(constraints, 4, 2, 1, 1, 0, 0);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Button exitButton = new Button("Exit");
		gridbag.setConstraints(exitButton, constraints);
		add(exitButton);
		exitButton.addActionListener(saveThis);
		for (int k=0 ; k<3 ; k++) {
			for (int j=0 ; j<3 ; j++) {
				buildConstraints(constraints, j, k, 1, 1, 25, 10);
				constraints.fill = GridBagConstraints.BOTH;
				buttArray[j+k*3]= new Button();
				buttArray[j+k*3].setFont(new Font("Sansserif",Font.BOLD,50));
				gridbag.setConstraints(buttArray[j+k*3], constraints);
				if (((this.black & 1<<(j+k*3))!=0) || ((this.white & 1<<(j+k*3))!=0))
					if ((this.white & 1<<(j+k*3))!=0) {
						buttArray[j+k*3].setLabel("O");
						enabled[j+k*3]=false;
					} else {
						buttArray[j+k*3].setLabel("X");
						enabled[j+k*3]=false;
					}
				else enabled[j+k*3]=true;
				add (buttArray[j+k*3]);
				buttArray[j+k*3].setEnabled(false);				// Disabilito inizialmente i bottoni
				buttArray[j+k*3].addActionListener(this);	// Registro l'ascoltatore dei bottoni
			}
		}
	}
	
	public int indexButton ( Button b) {		// Metodo che, dato un bottone b mi trova quale dei nove della
		int result=-1;										// griglia 
		for (int j=0;j<9;j++)
			if (buttArray[j]==b) {
				result=j;
				return(result);
			}
		return (result);
	}
		
	final static int moves[] = {4, 0, 2, 6, 8, 1, 3, 5, 7};	// Queste sono le caselle
	static boolean won[] = new boolean[1 << 9];		// Array che tiene in conto le posizioni vincenti
	static final int DONE = (1 << 9) - 1;				// Inizializzazione di alcune costanti
	static final int OK = 0;
	static final int WIN = 1;
	static final int LOSE = 2;
	static final int STALEMATE = 3;
	
	static void isWon(int pos) {					// Verifica se la posizione  vincente
		for (int i = 0 ; i < DONE ; i++) {
			if ((i & pos) == pos) {
				won[i] = true;
			}
		}
	}

	static {															// Inizializza le posizioni vincenti
		isWon((1 << 0) | (1 << 1) | (1 << 2)); // Prima riga
		isWon((1 << 3) | (1 << 4) | (1 << 5)); // Seconda riga
		isWon((1 << 6) | (1 << 7) | (1 << 8)); // Terza riga
		isWon((1 << 0) | (1 << 3) | (1 << 6)); // Prima colonna
		isWon((1 << 1) | (1 << 4) | (1 << 7)); // Seconda colonna
		isWon((1 << 2) | (1 << 5) | (1 << 8)); // Terza colonna
		isWon((1 << 0) | (1 << 4) | (1 << 8)); // Diagonale principale
		isWon((1 << 2) | (1 << 4) | (1 << 6)); // Diagonale secondaria
	}

	int status() {									// Verifica lo stato del gioco
		if (won[white]) { 							// Se ha vinto l'utente locale
			return WIN;
		}
		if (won[black]) { 							// Se ha vinto l'utente remoto
			return LOSE;
		}
		if ((black | white) == DONE) { 	// Se la griglia  gi piena
			return STALEMATE;
		}
		return OK; 										// Se non ha vinto nessuno e non  finita la partita ritorna OK
	}

	public void destroy() {					// Al termine del thread rimuove gli ascoltatori
		for (int i=0; i<9; i++)
			buttArray[i].removeActionListener(this);
	}

	public void actionPerformed(ActionEvent e) {						// Controllo della pressione di un bottone
		
		String mossa=new String();
		if (((Button)e.getSource()).getLabel().equals("exit")){
			f.setVisible(false);
			f.dispose();
			app.setVisible(true);
			app.remove(app.Lista);
			app.Lista.setSize(100,100);						
			app.Lista.setLocation(50,50);
			if (call==true){													// posso interrompere il gioco solamente se sono stato io
				try {																		// a chiamare l'avversario
					end.writeObject("endplay");
				}
				catch (IOException evt) {
					System.out.println("Il server  caduto");
					app.ripristina(app);
				}
				stop();
			}
		}
		for (int j=0 ; j<9 ; j++)														// Disabilito tutti i bottoni non ancora
			if (enabled[j]) 																// premuti per evitare clic spuri
				buttArray[j].setEnabled(false);
		int mia=indexButton((Button)e.getSource());						// Quale bottone ho premuto?
		white |= 1 << mia;																	// Aggiorno la mia posizione
		enabled[mia] = false;
		buttArray[mia].setLabel("O");												// Segno un "O" nella casella premuta
		try {
			out.writeObject(String.valueOf(mia));							// Mando la mia mossa all'avversario
		} catch (IOException evt) {
			System.out.println("Errore di I/O");
		}
		int tua=10;
		switch (status()) {														// Controllo lo stato del gioco
			case WIN:
				resultArea.add("Hai vinto");
				break;
			case LOSE:
				resultArea.add("Hai perso");
				break;
		}
		switch (status()) {																// Controllo dello stato del gioco
			case WIN:
			case LOSE:
			case STALEMATE: 																// Se il gioco  finito
				for (int j=0 ; j<9 ; j++) {											// Disabilito tutti i bottoni per evitare clic 
					buttArray[j].setEnabled(false);								// spuri
				}
				white = black = 0;															// Azzero le posizioni dei giocatori
				for (int i=0;i<9;i++) {												//	 Ripristino la griglia vuota
					buttArray[i].setLabel("");
					enabled[i]=true;														// e la condizione dei bottoni
				}
				try {																				// Mi fermo per 2 secondi
					Thread.sleep(2000);
				} catch (InterruptedException evt) {}
				if (!first) { 																// Se sono il secondo del prossimo gioco
					f.setTitle(MyName+" - Secondo");
					try {
						mossa = (String) in.readObject();						// Leggo la mossa dell'avversario
					} catch (ClassNotFoundException evt) {
						System.out.println("Errore di classe");
					}
					catch (IOException evt) {}
					if (mossa.equals("exit")) {												// Se l'avversario si disconnette
						f.setVisible(false);
						f.dispose();
						app.setVisible(true);
						app.remove(app.Lista);
						app.Lista.setSize(100,100);						
						app.Lista.setLocation(50,50);
						if (call==true){													// posso interrompere il gioco solamente se sono stato io
							try {																		// a chiamare l'avversario
								end.writeObject("endplay");
							}	catch (IOException evt) {
								System.out.println("Il server  caduto");
								app.ripristina(app);
							}
							stop();
						}
						return;
					}
					tua=(new Integer(mossa)).intValue();
					black |= 1 << tua;														// Aggiorno la tua posizione
					enabled[tua]=false;													// Disabilito il bottone premuto
					buttArray[tua].setLabel("X");									// Segno una "X" nel bottone premuto
				} else f.setTitle(MyName+" - Primo");
				for (int j=0 ; j<9 ; j++) 											// Ripristino i bottoni non ancora premuti
					if (enabled[j])														
						buttArray[j].setEnabled(true);
				first = !first; 															// Il prossimo gioco partir alternato
				return;																			// Esco da actionPerformed
			default:
				try {
					mossa = (String) in.readObject();							// Leggo la mossa dell'avversario
				} catch (ClassNotFoundException evt) {
					System.out.println("Errore di classe");
				}	catch (IOException evt) {
					System.out.println("Errore di I/O");
				}
				if (mossa.equals("exit")) {												// Se l'avversario si disconnette
					f.setVisible(false);
					f.dispose();
					app.setVisible(true);
					app.remove(app.Lista);
					app.Lista.setSize(100,100);						
					app.Lista.setLocation(50,50);
					if (call==true){							// posso interrompere il gioco solamente se sono stato io a chiamare
						try {												// l'avversario
							end.writeObject("endplay");
						}	catch (IOException evt) {
							System.out.println("Il server  caduto");
							app.ripristina(app);
						}
						stop();
					}
					return;
				}
				tua=(new Integer(mossa)).intValue();
				black |= 1 << tua;															// Aggiorno la tua posizione
				enabled[tua]=false;														// Disabilito il bottone premuto
				buttArray[tua].setLabel("X");										// Segno una "X" nel bottone premuto
				for (int j=0 ; j<9 ; j++) 											// Ripristino i bottoni non ancora premuti
					if (enabled[j])
						buttArray[j].setEnabled(true);
				switch (status()) {														// Controllo lo stato del gioco
					case WIN:
						resultArea.add("Hai vinto");
						break;
					case LOSE:
						resultArea.add("Hai perso");
						break;
				}
				switch (status()) {														// Controllo lo stato del gioco
					case WIN:
					case LOSE:
					case STALEMATE: 														// Se il gioco  finito
						for (int j=0 ; j<9 ; j++) {									// Disabilito tutti i bottoni
							enabled[j]=false;
							buttArray[j].setEnabled(false);
						}
						white = black = 0;													// Azzero le posizioni dei giocatori
						for (int i=0;i<9;i++) {										// Ripristino la griglia vuota
							buttArray[i].setLabel("");
							enabled[i]=true;												// e la condizione dei bottoni
						}
						try {																		// Mi fermo per 2 secondi
							Thread.sleep(2000);
						} catch (InterruptedException evt) {}
						if (!first) { 														// Se sono il secondo del prossimo gioco
							f.setTitle(MyName+" - Secondo");
							try {
								mossa = (String) in.readObject();				// Leggo la mossa dell'avversario
							} catch (ClassNotFoundException evt) {
								System.out.println("Errore di classe");
							}
							catch (IOException evt) {
								System.out.println("Errore di I/O");
							}
							if (mossa.equals("exit")) {												// Se l'avversario si disconnette
								f.setVisible(false);
								f.dispose();
								app.setVisible(true);
								app.remove(app.Lista);
								app.Lista.setSize(100,100);						
								app.Lista.setLocation(50,50);
								if (call==true){								//posso interrompere il gioco solamente se sono stato
									try {													// io a chiamare
										end.writeObject("endplay");
									}	catch (IOException a) {
										System.out.println("Il server  caduto");
										app.ripristina(app);
									}
									stop();
								}
								return;
							}
							tua=(new Integer(mossa)).intValue();
							black |= 1 << tua;												// Aggiorno la tua posizione
							enabled[tua]=false;											// Disabilito il bottone premuto
							buttArray[tua].setLabel("X");							// Segno una "X" nel bottone premuto
						} else f.setTitle(MyName+" - Primo");
						for (int j=0 ; j<9 ; j++) 										// Ripristino i bottoni non ancora premuti
							if (enabled[j])
								buttArray[j].setEnabled(true);
						first = !first; 														// Il prossimo gioco partir alternato
						return;																		// esco da actionPerformed
				}
		}
	}
	
	public void windowClosing(WindowEvent e) {				// Operazioni per la chiusura della finestra
		if (call==false){
			destroy();
			e.getWindow().setVisible(false);
			e.getWindow().dispose();
			try {
				out.writeObject("exit");
			} catch (IOException evt) {
				System.out.println("Errore di I/O");
			}
			// gestione uscita dal Thread
			app.setVisible(true);
			app.remove(app.Lista);
			app.Lista.setSize(100,100);						
			app.Lista.setLocation(50,50);
		}
	}
	public void windowOpened(WindowEvent evt ){}
	public void windowIconified(WindowEvent evt ){}
	public void windowDeiconified(WindowEvent evt ){}
	public void windowClosed(WindowEvent evt ){}
	public void windowActivated(WindowEvent evt ){}
	public void windowDeactivated(WindowEvent evt ){}
	public void mousePressed(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}

	public void run() {

		int tua=10;
		String mossa=new String();									// Inizializzo il frame
		f=new Frame();
		if (first)
			f.setTitle(MyName+" - Primo");
		else
			f.setTitle(MyName+" - Secondo");				
		f.addWindowListener(this);
		f.setSize (600,300);
		f.setLocation(100,150);
		f.add(this);
		f.show();
	
		if (!first) { 														// Se sono il secondo
			try {
				mossa = (String) in.readObject();				// Leggo la mossa dell'avversario
			} catch (ClassNotFoundException evt) {
				System.out.println("Errore di classe");
			}
			catch (IOException evt) {
				System.out.println("Errore di I/O");
			}
			if (mossa.equals("exit")) {					// comunico al server che sto chiudendo
				try {
					end.writeObject("endplay");	
				} catch (IOException a) {
					System.out.println("Il server  caduto");
					app.ripristina(app);
				}
				f.setVisible(false);
				f.dispose();
				app.setVisible(true);
				app.remove(app.Lista);
				app.Lista.setSize(100,100);						
				app.Lista.setLocation(50,50);
			}
			tua=new Integer(mossa).intValue();
			black |= 1 << tua;												// Aggiorno la tua posizione
			enabled[tua]=false;											// Disabilito il bottone premuto
			buttArray[tua].setLabel("X");							// Segno una "X" nel bottone premuto
		}
		for (int j=0 ; j<9 ; j++) {									// Ripristino i bottoni non ancora premuti
			if (enabled[j])
				buttArray[j].setEnabled(true);
			first= !first;														// La prossima volta parto alternato
		}
	}
}

class SaveListener implements ActionListener {
	
	Tris app;
	DataOutputStream outFile;
		
	SaveListener (Tris client) {
		app=client;
	}
	
	public void actionPerformed(ActionEvent e) {
	
		if (((Button) e.getSource()).getLabel().equals("Save")) {
			FileDialog salva = new FileDialog(app.f,"Save game...",FileDialog.SAVE);
			salva.show();
			String file = salva.getFile();
			salva.setVisible(false);
			salva.dispose();
			try {
				outFile = new DataOutputStream (new FileOutputStream(file));
				outFile.writeUTF("Tris Over The Net Savefile");
				outFile.writeUTF(app.MyName);
				outFile.writeUTF(app.player);
				outFile.writeUTF(String.valueOf(app.white));
				outFile.writeUTF(String.valueOf(app.black));
				if (app.first)
					outFile.writeUTF("true");
				else
					outFile.writeUTF("false");
				outFile.close();
			} catch (IOException evt) {
				System.out.println("Errore di I/O");
			}
		}	else {
			if (app.call==false){
				app.f.setVisible(false);
				app.f.dispose();
				try {
					app.out.writeObject("exit");
				} catch (IOException evt) {
					System.out.println("Errore di I/O");
				}
				// gestione uscita dal Thread
				app.app.setVisible(true);
				app.app.remove(app.app.Lista);
				app.app.Lista.setSize(100,100);						
				app.app.Lista.setLocation(50,50);
			}
		}
	}
}