import java.net.*;
import java.awt.*;
import java.io.*;
import java.awt.event.*;

class UserDialog extends Dialog implements ActionListener {

	TextField tfname;
	TextField tfpass;

	void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh, int wx, int wy) {
		gbc.gridx = gx;
		gbc.gridy = gy;
		gbc.gridwidth = gw;
		gbc.gridheight = gh;
		gbc.weightx = wx;
		gbc.weighty = wy;
  	}

	UserDialog (Frame parent, String title, boolean modal){
		super(parent,title,modal);
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();	
		setLayout(gridbag);
		setBackground(Color.lightGray);
		// Name label	
		buildConstraints(constraints, 0, 0, 1, 1, 10, 40);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.EAST;
		Label label1 = new Label("Name:", Label.LEFT);
		gridbag.setConstraints(label1, constraints);
		add(label1);
		// Name text field
		buildConstraints(constraints, 1, 0, 2, 1, 90, 0);
		constraints.fill = GridBagConstraints.HORIZONTAL;
		tfname = new TextField();
		gridbag.setConstraints(tfname, constraints);
		add(tfname);
		// password label
		buildConstraints(constraints, 0, 1, 1, 1, 0, 40);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.EAST;
		Label label2 = new Label("Password:", Label.LEFT);
		gridbag.setConstraints(label2, constraints);
		add(label2);
		// password text field	
		buildConstraints(constraints, 1, 1, 2, 1, 0, 0);
		constraints.fill = GridBagConstraints.HORIZONTAL;
		tfpass = new TextField();	
		tfpass.setEchoChar('*');
		gridbag.setConstraints(tfpass, constraints);
		add(tfpass);
		// Accedi Button
		buildConstraints(constraints, 0, 2, 1, 1, 0, 20);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Button accediButton = new Button("Accedi");
		gridbag.setConstraints(accediButton, constraints);
		add(accediButton);
		accediButton.addActionListener(this);
		// Registra Button
		buildConstraints(constraints, 1, 2, 1, 1, 0, 20);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Button recButton = new Button("Registra");
		gridbag.setConstraints(recButton, constraints);
		add(recButton);
		recButton.addActionListener(this);
		// Annulla Button
		buildConstraints(constraints, 3, 2, 1, 1, 0, 20);
		constraints.fill = GridBagConstraints.NONE;
		constraints.anchor = GridBagConstraints.CENTER;
		Button cancelButton = new Button("Annulla");
		gridbag.setConstraints(cancelButton, constraints);
		add(cancelButton);
		cancelButton.addActionListener(this);
		setSize(350,150);
		setLocation(225,225);
	}

	public void actionPerformed(ActionEvent e) {
		
		String label = ((Button)e.getSource()).getLabel();
		if (label.equals("Accedi") || label.equals("Registra"))	{
			if (tfname.getText().equals("") || tfpass.getText().equals("")){
				Frame errore = new Frame("Errore!");
				errore.setSize(100,100);
				errore.setLocation(350,250);
				errore.setBackground(Color.red);
				errore.setFont(new Font("Arial",Font.BOLD,14));
				Label errLab=new Label("Errore!",Label.CENTER);
				errore.add(errLab);
				errore.setVisible(true);
				try{
					Thread.sleep(2000);
				} catch (InterruptedException evt) {}
				errore.setVisible(false);
				errore.dispose();
				requestFocus();
			}
			else { 
				setVisible(false);
				dispose();	
				if (label.equals("Accedi"))
					((Client) getParent()).Collegamento(tfname.getText(),tfpass.getText(),"a");
				else 
					((Client) getParent()).Collegamento(tfname.getText(),tfpass.getText(),"r");
			}
		}
		else if (label.equals("Annulla")) {
				setVisible(false);
		}
	}
}