import java.io.*;
import java.net.*;
import java.awt.*;
import java.sql.Timestamp;
import ListOf;
import server.Performance;


public class Server extends Thread {
	NewServer serv;
	ServerSocket serverSk;
	Socket clientSocket;
	ListOfNmPw listaNamePwd=new ListOfNmPw();
	ListOfNames listaNomiAttivi=new ListOfNames();
	ListOfAddr listAddr=new ListOfAddr();
	listenRequest listen;
	Thread ThListen;
	FrameControl fCntrl = new FrameControl("Console Server");


	//oggetti per la gestione dei file
	File file;
	FileInputStream fin;
	FileOutputStream fout;
	ObjectOutputStream oOut;
	ObjectInputStream oIn;

  Performance Perform=new Performance();
	
	public void run() {
		int car;
		/* caricamento della lista su file ed eventuale creazione del file
		che la deve contenere */
		file=new File("utentiR");
		fCntrl.setVisible(true);
    Perform.setVisible(true);
		try {
			if (!(file.exists()))
				file.createNewFile();
			fin=new FileInputStream(file);
			oIn=new ObjectInputStream(fin);
			if (file.exists()) listaNamePwd=(ListOfNmPw)(oIn.readObject());
			oIn.close();
			fin.close();
		}
		catch (IOException e){ 
			fCntrl.err.add("Errore di I/O: possibile errore sul file UtentiR");
		}
		catch (ClassNotFoundException e){
			fCntrl.err.add("Errore in lettura");
		}
		try {
			serverSk = new ServerSocket(4321);
			while (true) {
				clientSocket=serverSk.accept();							//attesa di una connessione.
				serv=new NewServer(clientSocket,listaNamePwd,listAddr,listaNomiAttivi,this);
				/*
				Stabilita la connessione, viene creato un nuovo oggetto NewServer, 
				estensione di Thread, al quale si passa il riferimento alla socket 
				con il client e il riferimento all'oggetto Lista.
				*/ 
				serv.start();
				/*Esecuzione del nuovo Thread serv. In parallelo agli altri Thread
					che gestiscono le richieste di altri client. E' stato realizzato
					un server parallelo.*/
				}			
		}
		catch (IOException e) {
			fCntrl.err.add("Errore accept");
		}
	}
	
	public static void main(String[] args) {
		Server server = new Server();
		server.start();		
	}	
}

class NewServer extends Server {
	
	Server app;
	Socket tempSocket;
	ListOfNmPw lista;
	ListOfNames listaNomi,NomiAttivi;
	ObjectInputStream in;
	ObjectOutputStream out,outEvt;
	Object array[];
	NamePwd user;
	Addr addr;
	Name NameOut;
	String nome=new String();
	String tipo=new String();
	String response=new String();
	String Ip;
	char ch[]={'a','s'};
	int port,gamePort;
	FrameControl fCntrl;
  Performance Perform;
	InetAddress clientIp;

  Timestamp Time1,Time2;
	long diff;
			
	NewServer (Socket client, ListOfNmPw listaNamePwd, ListOfAddr listaddr, ListOfNames Attivi,Server app) {
		clientSocket=client;
		this.lista=listaNamePwd;
		listAddr=listaddr;
		NomiAttivi=Attivi;
		this.app=app;
		this.fCntrl=app.fCntrl;
    this.Perform=app.Perform;
	}

	public void Stop(){
		app.serv=null;
	}

	public void run(){
		try {
			in = new ObjectInputStream(clientSocket.getInputStream());
			out = new ObjectOutputStream(clientSocket.getOutputStream());
		}	catch (IOException e) {
			fCntrl.err.add("Errore in apertura degli stream");
		}
		/*
		Creazione degli stream di Output ed Input, da associare alla
		ClientSocket stablita con il client.
		*/
		try {
			clientIp=clientSocket.getInetAddress();
			/* il server riceve dal client un identificatore che definisce il
			tipo d'interazione: registrazione o riconoscimento dell'utente */
			user = ((NamePwd)in.readObject());
			port =((Integer)(in.readObject())).intValue();
			gamePort=((Integer)(in.readObject())).intValue();
			tipo = ((String)in.readObject());

			//prima marcatura temporale
			Time1=new Timestamp(System.currentTimeMillis());
			//Lettura dallo stream di input del nome inviato dal Client.
			//Lettura del tipo di interazione: a=accesso, r=registrazione
			ch[0]='0';
			tipo.getChars(0,1,ch,0);
			switch (ch[0]) {
				case (int)'r':	{
					synchronized (lista) {  //proteggo la sezione critica
						if (!(lista.contains(user))) {
							lista.addToList(user);
							response="yr";
							try {
								app.fout=new FileOutputStream(app.file);
								app.oOut=new ObjectOutputStream(app.fout);
                //Scrittura su file
								app.oOut.writeObject(lista);
								app.oOut.close();
								app.fout.close();
							}
							catch (IOException e){
								fCntrl.err.add("Errore: impossibile scrivere la lista sullo stream di output");
							}
						}
						else response="n";  //errore
					}
					break;
				}
				case (int)'a':	{
					synchronized (lista) {	 //proteggo la sezione critica
						if (lista.exist(user))
							response="ya";
						else response="n";
					}
				}
				break;
			}
		}	catch (IOException e) {
			fCntrl.err.add("Errore di I/O "+e.toString());
      fCntrl.err.add("Errore irreversibile: terminazione del Thread");
      Stop();
		}
		catch (ClassNotFoundException e) {
			fCntrl.err.add("Errore in lettura");
		}
		/* aggiungo i nomi alle varie liste solamente se la registrazione/accesso
		 andato a buon fine  */
		if (response=="yr" || response=="ya"){
			fCntrl.text.add(user.nome+" si  collegato");
			addr=new Addr(user.nome,clientIp.getHostAddress(),""+port,""+gamePort);
			listAddr.addToList(addr);
			NomiAttivi.addToList(new Name(user.nome));
		}
		/*
		Invio al Client,tramite lo stream di output, di una risposta affermativa,
		cio il carattere 'y' per la ricezione del Nick-name.
		*/
		array=listAddr.toArray();
		listaNomi=new ListOfNames();
		NomiAttivi.displayList(fCntrl.lst);
		try {
			out.writeObject(response);
			/*invio la lista dei client attivi solo se la registrazione/accesso 
			 andata a buon fine */
			if (response=="yr" || response=="ya"){
				synchronized (NomiAttivi) {
					out.writeObject(NomiAttivi);

          //seconda marcatura temporale
          Time2=new Timestamp(System.currentTimeMillis());
          //calcolo del tmpo di risposta in millisecondi
          diff=(Time2.getTime()-Time1.getTime())*1000000+(Time2.getNanos()-Time1.getNanos());
          float milliDif=diff/1000000;
          //stampa sul performance monitor del server del tempo di risposta
          Perform.textArea.append("Tempo di risposta  "+user.nome+": "+milliDif+" [msec]\n");
				}
			}
		} catch (IOException e) {

    /////////////////////////
    //gestione dell'eccezione
    /////////////////////////
    
			fCntrl.err.add("2: "+e.toString());
		}

		if (response=="yr" || response=="ya"){
			/* Thread di ascolto sul canale appena stabilito con il client */
			listen=new listenRequest(this);
			ThListen=new Thread(listen);
			ThListen.setName(user.nome);
			ThListen.start();
		}
		/* notifica inserimento a tutti i client attivi */
		array=listAddr.toArray();
		if (response=="yr" || response=="ya"){
			synchronized (lista) {	//proteggo la sezione critica
				synchronized (listAddr) {

        //Marcatura temporale
        Time1=new Timestamp(System.currentTimeMillis());
        //Ciclo "for" per il multicast
					for (int i=0;i<listAddr.size();i++) {
					//creazione socket di notifica eventi
						Ip=((Addr)array[i]).Ip;
						port=(new Integer(((Addr)array[i]).Port)).intValue();
						NameOut=new Name(user.nome);
						if (!( ((Addr)array[i]).name.equals(user.nome))){
							try {
								tempSocket=new Socket(Ip,port);
								outEvt = new ObjectOutputStream(tempSocket.getOutputStream());
								outEvt.writeObject("a");
								outEvt.writeObject(NameOut);
								outEvt.close();
								tempSocket.close();
							}	catch (IOException e) {

              /////////////////////////
              //gestione dell'eccezione
              /////////////////////////
              Name nameOutF=new Name(((Addr)array[i]).name);

              try {
              outEvt.close();               //chiusura dello stream di output
              tempSocket.close();           //chiusura della socket temporanea
              } catch (IOException e1){fCntrl.err.add("3.1: "+e1.toString());}

              fCntrl.err.add("3: "+e.toString());
              fCntrl.err.add("Errore irreversibile: terminazione del Thread");

              /* gestione errore: disinserimento del Nome dalla lista dei client
              attivi e terminazione del Thread. */

              synchronized (listAddr) {
						    i=listAddr.index(NameOut);
						    array=listAddr.toArray();
						    listAddr.removeFromList((Addr)array[i]);
					    }
					    synchronized (NomiAttivi){
						    i=NomiAttivi.index(NameOut);
						    array=NomiAttivi.toArray();
						    NomiAttivi.removeFromList((Name)array[i]);
					    }

              /* per un corretto funzionamento del intero sistema, composto dal server e dal client,
              si dovrebbe notificare a tutti i client rimasti la rimozione dei vari client con i quali
               caduta la "Socket", poich non sarebbe pi possibile stabilire una comunicazione con loro */

              //notifica disinserimento del client che  caduto
              Object[] arrayTemp=listAddr.toArray();
              
              for (int j=0;i<listAddr.size();i++) {
              Ip=((Addr)arrayTemp[j]).Ip;
              port=(new Integer(((Addr)arrayTemp[j]).Port)).intValue();

              try {
								tempSocket=new Socket(Ip,port);
								outEvt = new ObjectOutputStream(tempSocket.getOutputStream());
								outEvt.writeObject("r");
								outEvt.writeObject(nameOutF);
								outEvt.close();
								tempSocket.close();
							}catch (IOException e1){ fCntrl.err.add("3.2: "+e1.toString());}

              }//for


					    NomiAttivi.displayList(fCntrl.lst);
              ThListen.stop();
              Stop();
              }  //catch
						}
					}//for
          
          //Marcatura temporale
          Time2=new Timestamp(System.currentTimeMillis());
          diff=(Time2.getTime()-Time1.getTime())*1000000+(Time2.getNanos()-Time1.getNanos());
          float milliDif=diff/1000000;
          //stampa sul performance monitor del server del tempo di risposta
          Perform.textArea.append("Multicast: "+milliDif+" [msec]\n");
				}
			}
		}
			/* il blocco dela sezione critica  necessario per tutta la 
					durata del broadcast, per evitare che la lista subisca variazioni
					indesiderate proprio in questo periodo di tempo */ 
	}
}

class listenRequest implements Runnable {
	
	NewServer app;
	String Req,Sname="",Pname="",Ip;
	Socket tempSocket;
	ObjectOutputStream out;
	Object[] array;
	int i,num;
	Addr AddrPname,AddrSname;
	FrameControl fCntrl;
  Performance Perform;

  Timestamp Time1,Time2;
  long diff;

	listenRequest(NewServer app) {
		this.fCntrl=app.fCntrl;
		this.app=app;
    this.Perform=app.Perform;
	}
	
	public void stop(){
		app.ThListen=null;
	}

	public void run() {
		Thread thisThread=Thread.currentThread();
		Object[] array;
		
		int index;
		while (app.ThListen==thisThread) {
			try {
				Req=(String)(app.in.readObject());				// Legge la richiesta di un Client
				if (Req.equals("play")) {
					Pname=(String)(app.in.readObject());
					Sname=(String)(app.in.readObject());
			 		if (app.listAddr.contains(Sname)) {
						/* comunica al client l'indirizzo Ip del giocatore avversario
						e il numero della porta adibita al gioco */
						index=app.listAddr.index(Sname);
						array=app.listAddr.toArray();
						app.out.writeObject(((Addr)array[index]).Ip);
						app.out.writeObject(((Addr)array[index]).gamePort);

						//notifica disinserimento dei client occupati in partita
						synchronized(app.NomiAttivi){
							i=app.NomiAttivi.index(Pname);
							array=app.NomiAttivi.toArray();
							app.NomiAttivi.removeFromList((Name)array[i]);
						}
						synchronized (app.NomiAttivi){
							// rimuovo Sname
							i=app.NomiAttivi.index(Sname);
							array=app.NomiAttivi.toArray();
							app.NomiAttivi.removeFromList((Name)array[i]);
						}
						app.NomiAttivi.displayList(fCntrl.lst);
						array=app.listAddr.toArray();
						synchronized(app.lista) {
							synchronized(app.listAddr){

              //Marcatura temporale
              Time1=new Timestamp(System.currentTimeMillis());
              //Ciclo "for" per il multicast
								for (int i=0;i<app.listAddr.size();i++) {
									Ip=((Addr)array[i]).Ip;
									num=(new Integer(((Addr)array[i]).Port)).intValue();
									tempSocket=new Socket(Ip,num);
									out = new ObjectOutputStream(tempSocket.getOutputStream());
									// notifica di rimozione
									out.writeObject("2r");
									out.writeObject(new Name(Sname));
									out.writeObject(new Name(Pname));
									out.close();
									tempSocket.close();
								}

                //Marcatura temporale
                Time2=new Timestamp(System.currentTimeMillis());
                diff=(Time2.getTime()-Time1.getTime())*1000000+(Time2.getNanos()-Time1.getNanos());
                float milliDif=diff/1000000;
                //stampa sul performance monitor del server del tempo di risposta
                Perform.textArea.append("Multicast (rimozione giocatori): "+milliDif+" [msec]\n");
							}
						}
					}
				// se viene chiamato con Sname="" DOVREBBE segnalare errore, ma non fa niente.....
				// da implementare....
				}//if play

				if (Req.equals("endplay")){
					// fine partita: notifica reinserimento giocatori
					array=app.listAddr.toArray();
					synchronized (app.NomiAttivi){
						app.NomiAttivi.addToList(new Name(Sname));
						app.NomiAttivi.addToList(new Name(Pname));
					}
					app.NomiAttivi.displayList(fCntrl.lst);
					synchronized (app.lista) {  //proteggo la sezione critica
						synchronized (app.listAddr) {

            //Marcatura temporale
            Time1=new Timestamp(System.currentTimeMillis());

            //Ciclo "for" per il multicast
							for (int i=0;i<app.listAddr.size();i++) {
							//creazione socket di notifica eventi
								Ip=((Addr)array[i]).Ip;
								num=(new Integer(((Addr)array[i]).Port)).intValue();
								try {
									tempSocket=new Socket(Ip,num);
									out = new ObjectOutputStream(tempSocket.getOutputStream());
									out.writeObject("2a");
									out.writeObject(new Name(Sname));
									out.writeObject(new Name(Pname));
									out.close();
									tempSocket.close();
								}	catch (IOException e) {
									fCntrl.err.add("4: "+e.toString());
                  }
							}

              //Marcatura temporale
              Time2=new Timestamp(System.currentTimeMillis());
              diff=(Time2.getTime()-Time1.getTime())*1000000+(Time2.getNanos()-Time1.getNanos());
              float milliDif=diff/1000000;
              //stampa sul performance monitor del server del tempo di risposta
              Perform.textArea.append("Multicast (reinserimento giocatori): "+milliDif+" [msec]\n");
						}
					}
				} // if endplay

				if (Req.equals("close")) {
					Sname=(String)(app.in.readObject());
					/* aggiorna la lista dei client attivi rimuovendo il client che si
					  scollegato */
					synchronized (app.listAddr) {
						i=app.listAddr.index(Sname);
						array=app.listAddr.toArray();
						app.listAddr.removeFromList((Addr)array[i]);
					}
					synchronized (app.NomiAttivi){
						i=app.NomiAttivi.index(Sname);
						array=app.NomiAttivi.toArray();
						app.NomiAttivi.removeFromList((Name)array[i]);
					}
					app.NomiAttivi.displayList(fCntrl.lst);

					// notifica a tutti i client la variazione
					array=app.listAddr.toArray();
					synchronized(app.lista){
						synchronized(app.listAddr){

              //Marcatura temporale
              Time1=new Timestamp(System.currentTimeMillis());

              //Ciclo "for" per il multicast
							for (int i=0;i<app.listAddr.size();i++) {
								Ip=((Addr)array[i]).Ip;
								num=(new Integer(((Addr)array[i]).Port)).intValue();
								tempSocket=new Socket(Ip,num);
								out = new ObjectOutputStream(tempSocket.getOutputStream());

								// notifica di rimozione
								out.writeObject("r");
								out.writeObject(new Name(Sname));
								out.close();
								tempSocket.close();
								app.in.close();
								app.out.close();
								app.clientSocket.close();
								this.stop();
								app.Stop();
							}

              //Marcatura temporale
              Time2=new Timestamp(System.currentTimeMillis());
              diff=(Time2.getTime()-Time1.getTime())*1000000+(Time2.getNanos()-Time1.getNanos());
              float milliDif=diff/1000000;
              //stampa sul performance monitor del server del tempo di risposta
              Perform.textArea.append("Multicast (rimozione di un Client): "+milliDif+" [msec]\n");

							if (app.listAddr.size()==0) {
								app.in.close();
								app.out.close();
								app.clientSocket.close();
								this.stop();
								app.Stop();
							}
						}
					}
					/* il blocco dela sezione critica  necessario per tutta la
					durata del broadcast, per evitare che la lista subisca variazioni
					indesiderate proprio in questo periodo di tempo */
					fCntrl.text.add(Sname+" si  scollegato");
				}//if close

				if (Req.equals("deny")) {
					// l'avversario ha rifiutato: notifica reinserimento giocatori
					Pname=(String)(app.in.readObject());
					Sname=(String)(app.in.readObject());
					array=app.listAddr.toArray();
					synchronized (app.NomiAttivi){
						app.NomiAttivi.addToList(new Name(Sname));
						app.NomiAttivi.addToList(new Name(Pname));
					}
					app.NomiAttivi.displayList(fCntrl.lst);
					synchronized (app.lista) {	 //proteggo la sezione critica
						synchronized (app.listAddr) {

              //Marcatura temporale
              Time1=new Timestamp(System.currentTimeMillis());

              //Ciclo "for" per il multicast
							for (int i=0;i<app.listAddr.size();i++) {

						//creazione socket di notifica eventi
								Ip=((Addr)array[i]).Ip;
								num=(new Integer(((Addr)array[i]).Port)).intValue();
								try {
									tempSocket=new Socket(Ip,num);
									out = new ObjectOutputStream(tempSocket.getOutputStream());
									out.writeObject("2a");
									out.writeObject(new Name(Sname));
									out.writeObject(new Name(Pname));
									out.close();
									tempSocket.close();
								}	catch (IOException e) {
									fCntrl.err.add("5: "+e.toString());
                  }
							}

              //Marcatura temporale
              Time2=new Timestamp(System.currentTimeMillis());
              diff=(Time2.getTime()-Time1.getTime())*1000000+(Time2.getNanos()-Time1.getNanos());
              float milliDif=diff/1000000;
              //stampa sul performance monitor del server del tempo di risposta
              Perform.textArea.append("Multicast (reinserimento giocatori): "+milliDif+" [msec]\n");
						}
					}
				} // if deny

			} catch (IOException e){
					Sname=app.ThListen.getName();
					fCntrl.err.add(Sname+"  caduto, aggiorno...");
					synchronized (app.listAddr) {
						i=app.listAddr.index(Sname);
						array=app.listAddr.toArray();
						app.listAddr.removeFromList((Addr)array[i]);
					}
					synchronized (app.NomiAttivi){
						i=app.NomiAttivi.index(Sname);
						array=app.NomiAttivi.toArray();
						app.NomiAttivi.removeFromList((Name)array[i]);
					}
					app.NomiAttivi.displayList(fCntrl.lst);

					// notifica a tutti i client la variazione
					array=app.listAddr.toArray();
					synchronized(app.lista){
						synchronized(app.listAddr){
							for (int i=0;i<app.listAddr.size();i++) {
								Ip=((Addr)array[i]).Ip;
								num=(new Integer(((Addr)array[i]).Port)).intValue();
								try {
									tempSocket=new Socket(Ip,num);
									out = new ObjectOutputStream(tempSocket.getOutputStream());

									// notifica di rimozione
									out.writeObject("r");
									out.writeObject(new Name(Sname));
									out.close();
									tempSocket.close();
									app.in.close();
									app.out.close();
									app.clientSocket.close();
								} catch(IOException evt) {
									fCntrl.err.add("6: "+e.toString());
								}
								this.stop();
								app.Stop();
							}
							if (app.listAddr.size()==0) {
								try {
									app.in.close();
									app.out.close();
									app.clientSocket.close();
									this.stop();
									app.Stop();
								} catch(IOException evt) {
									fCntrl.err.add("7: "+e.toString());
								}
							}
						}
					}
						
					/* il blocco dela sezione critica  necessario per tutta la 
					durata del broadcast, per evitare che la lista subisca variazioni
					indesiderate proprio in questo periodo di tempo */ 
				
					fCntrl.text.add(Sname+" si  scollegato");
					this.stop();		
				}
				catch (ClassNotFoundException i) {
					fCntrl.err.add("Errore di classe");
					this.stop();		
				}
		}	
	}
}